
; SCCSID = @(#)prtdd1.inc       6.10 91/10/04
;/**********************************************************************
;/*                                                                    *
;/*                       IBM/Microsoft Confidential                   *
;/*                                                                    *
;/*                 Copyright (c) IBM Corporation  1987 - 2001         *
;/*                 Copyright (c) Microsoft Corp.  1987, 1990          *
;/*                           All Rights Reserved                      *
;/*                                                                    *
;/**********************************************************************
;/********************** START OF SPECIFICATIONS ***********************/
;/*                                                                    */
;/* SUBROUTINE NAME: PRTDATA                                           */
;/*                                                                    */
;/* DESCRIPTIVE NAME: PRINTER DEVICE DRIVER EQUATES AND STRUCTURES     */
;/*                                                                    */
;/* Change Log                                                         */
;/*                                                                    */
;/*  Mark    yy/mm/dd  Programmer      Comment                         */
;/*  ----    --------  ----------      -------                         */
;/*          01/02/12  LR              PCI support added               */
;/*                                                                    */
;/*********************** END OF SPECIFICATIONS ************************/

hardware_specific       STRUC           ; HARDWARE SPECIFIC DATA AREA

;*****************************************************************************
;*  N O T E !!!!: The following DUP must be exactly enough to "overlay"      *
;*                the printer_database common vars in prtdd.inc              *
;*****************************************************************************

                db      40 DUP (0)      ; DEVICE DRIVER INDEPENDENT VARAIBLES

;*****************************************************************************
;*  N O T E !!!!: Do not add any members below without checking that it      *
;*                does not "overflow" the hardware_specific "hole" in        *
;*                prtdd.inc's printer_database structure                     *
;*****************************************************************************

initialcount    dw      0               ; INITIAL COUNT OF CHARACTERS TO PRINT
prtcount        dw      0               ; NUMBER OF CHARS. LEFT TO BE PRINTED
printbufoff     dw      0               ; OFFSET INTO PRINT BUFFER

intlevel        db      0               ; INTERRUPT LEVEL OF DEVICE
curintlevel     db      0               ; CURRENT INTERRUPT LEVEL OF DEVICE.
retryctr        db      0               ; RETRY IF DEVICE IS BUSY
;LR                db      0               ; FUTURE USE - KEEPS WORD ALIGNMENT
intp            db     40h              ;LR at initialization time:
                                        ; high nibble = interrupt pending bit when an interrupt has NOT occurred
                                        ; low  nibble = interrupt pin PCI interrupt pin
                                        ; at interrupt time: interrupt pending bit when an interrupt has NOT occurred
introutine      dw      0               ; OFFSET OF INTERRUPT ROUTINE
waittime        dw      0               ; TIME TO WAIT BEFORE PRINT NEXT CHAR
prttime         dw      0               ; RUNNING TIMER COUNT-DEV RUNS ON TIMER
prfvw_off       dw      0               ; OFFSET OF PERFVIEW COUNTERS
share_interrupt db      0               ; PRINTER SUPPORTS INT. SHARING
cancelstatus    db      0               ; PRINTER STATUS PORT DATA

hardware_specific       ENDS

