;/*****************************************************************************
;*
;* SOURCE FILE NAME = TOUDDERR.INC
;*
;* DESCRIPTIVE NAME = Touch device dependant error codes
;*
;* COPYRIGHT    COPYRIGHT IBM CORPORATION, 1991, 1992
;*              LICENSED MATERIAL - PROGRAM PROPERTY OF IBM
;*              REFER TO COPYRIGHT INSTRUCTION FORM#G120-2083
;*              RESTRICTED MATERIALS OF IBM
;*              IBM CONFIDENTIAL
;*
;* VERSION      V2.0
;*
;* DATE         09/05/91
;*
;* DESCRIPTION
;*
;* FUNCTIONS
;*
;*
;* NOTES        NONE
;*
;* STRUCTURES   NONE
;*
;* EXTERNAL REFERENCES
;*
;*              NONE
;*
;* EXTERNAL FUNCTIONS
;*
;*              NONE
;*
;* CHANGE ACTIVITY =
;*   DATE      FLAG        APAR   CHANGE DESCRIPTION
;*   --------  ----------  -----  --------------------------------------
;*   mm/dd/yy  @Vr.mpppxx  xxxxx  xxxxxxx
;*****************************************************************************/

ERR_ILLEGAL             equ     0       ; illegal parms to getputmessage
ERR_DD_MCOPEN           EQU     1       ; micro code file open error
ERR_DD_MCREAD           EQU     2       ; micro code file read error
ERR_DD_MCLEVEL          EQU     3       ; micro code levels incompatible
ERR_DD_MCABIOS          EQU     2       ; download micro code, ABIOS error
ERR_DD_LID              EQU     2       ; get LID failed
ERR_DD_GPARM            EQU     2       ; get LID parms failed
ERR_DD_SIRQ             EQU     2       ; set IRQ failed
ERR_DD_INIPOST          EQU     2       ; init get POST failed
ERR_DD_CDTOK            EQU     9       ; code= not found
ERR_DD_MCNAME           EQU     10      ; mc file name too big
ERR_DD_INIWAIT          EQU     2       ; init wait_cmd failed
INF_DD_SIGNON           EQU     12      ; sign on
;* INF_DD_SUCCESS       EQU     13      ; init successful
INF_DD_FAILURE          EQU     14      ; init failure
INF_DD_MOULD            equ     15      ; mouse loaded
INF_DD_DMC              equ     16      ; download micro code
;* ERR_DD_PEPARM        equ     17      ; emul=?, illegal parm
;* ERR_DD_REPARM        equ     18      ; /e:?, illegal parm
;* INF_DD_PARMS         equ     19      ; show parms
ERR_DD_INIRESET         equ     2       ; init reset timed out
ERR_DD_NOABIOS          equ     2       ; touch ABIOS not installed
ERR_DD_INIFAIL          equ     2       ; init reset failed
ERR_DD_INILEVEL         EQU     2       ; init get LEVEL failed
ERR_DD_INIENST          EQU     2       ; init enable stream failed
ERR_DD_INIGLP           EQU     2       ; init get lid parms failed
ERR_DD_INICNTR          EQU     2       ; init enable cont read failed
;* ERR_DD_FPARMS        EQU     27      ; filt=, illegal parms
ERR_DD_KBEN             EQU     2       ; keyboard enable failed
ERR_DD_KBDIS            EQU     2       ; keyboard disable failed
;* ERR_DD_SPARMS        equ     30      ; ++0.21d selection conf parms bad
;* ERR_DD_CPARMS        equ     31      ; ++0.21d click lock conf parms bad
;* ERR_DD_TPARMS        equ     32      ; ++0.21d threshold conf parms bad
ERR_DD_SELFTEST         equ     2       ; ++0.21f internal self test failed
ERR_DD_SOI_TO           equ     2       ; ++0.21g fatal abios failure
ERR_DD_INITOK           equ     35      ; init= not found
ERR_DD_ININAME          equ     36      ; init token too long
WRN_DD_INIFILE          equ     37      ; init file not found
WRN_DD_INISYNTAX        equ     38      ; init file syntax error
WRN_DD_INIGENERAL       equ     39      ; init file general failure
WRN_DD_INIDEFAULTS      equ     40      ; init failed use defaults
WRN_DD_INIARGS          equ     41      ; init token bad args

;*
;* end
;*
